diff --git a/src/modules/OpenGL2/OpenGL2.cpp b/src/modules/OpenGL2/OpenGL2.cpp
index b52c76be..a98a6f51 100644
--- a/src/modules/OpenGL2/OpenGL2.cpp
+++ b/src/modules/OpenGL2/OpenGL2.cpp
@@ -19,8 +19,6 @@
 #include <OpenGL2.hpp>
 #include <OpenGL2Writer.hpp>
 
-#include <QGuiApplication>
-
 OpenGL2::OpenGL2() :
     Module("OpenGL2")
 {
@@ -29,12 +27,8 @@ OpenGL2::OpenGL2() :
     init("Enabled", true);
     init("AllowPBO", true);
     init("HQScaling", false);
-    const QString platformName = QGuiApplication::platformName();
-    init("ForceRtt", (platformName == "cocoa" || platformName == "android"));
+#ifdef VSYNC_SETTINGS
     init("VSync", true);
-#ifdef Q_OS_WIN
-    if (QSysInfo::windowsVersion() >= QSysInfo::WV_6_0)
-        init("PreventFullScreen", true);
 #endif
 }
 
@@ -45,6 +39,7 @@ QList<OpenGL2::Info> OpenGL2::getModulesInfo(const bool showDisabled) const
         modulesInfo += Info(OpenGL2WriterName, WRITER, QStringList{"video"});
     return modulesInfo;
 }
+
 void *OpenGL2::createInstance(const QString &name)
 {
     if (name == OpenGL2WriterName && getBool("Enabled"))
@@ -76,35 +71,16 @@ ModuleSettingsWidget::ModuleSettingsWidget(Module &module) :
     hqScalingB = new QCheckBox(tr("High quality video scaling"));
     hqScalingB->setToolTip(tr("Trilinear filtering for minification and bicubic filtering for magnification."));
     hqScalingB->setChecked(sets().getBool("HQScaling"));
-
-    forceRttB = new QCheckBox(tr("Force render to texture if possible (not recommended)"));
-    forceRttB->setToolTip(tr("Always enabled on Wayland and Android platforms.\nSet visualizations to OpenGL mode if enabled."));
-    forceRttB->setChecked(sets().getBool("ForceRtt"));
-
+#ifdef VSYNC_SETTINGS
     vsyncB = new QCheckBox(tr("Vertical sync") +  " (VSync)");
     vsyncB->setChecked(sets().getBool("VSync"));
-
-#ifdef Q_OS_WIN
-    if (QSysInfo::windowsVersion() >= QSysInfo::WV_6_0)
-    {
-        preventFullScreenB = new QCheckBox(tr("Try to prevent exclusive full screen"));
-        preventFullScreenB->setChecked(sets().getBool("PreventFullScreen"));
-    }
-    else
-    {
-        preventFullScreenB = nullptr;
-    }
 #endif
-
     QGridLayout *layout = new QGridLayout(this);
     layout->addWidget(enabledB);
     layout->addWidget(allowPboB);
     layout->addWidget(hqScalingB);
-    layout->addWidget(forceRttB);
+#ifdef VSYNC_SETTINGS
     layout->addWidget(vsyncB);
-#ifdef Q_OS_WIN
-    if (preventFullScreenB)
-        layout->addWidget(preventFullScreenB);
 #endif
 }
 
@@ -113,10 +89,7 @@ void ModuleSettingsWidget::saveSettings()
     sets().set("Enabled", enabledB->isChecked());
     sets().set("AllowPBO", allowPboB->isChecked());
     sets().set("HQScaling", hqScalingB->isChecked());
-    sets().set("ForceRtt", forceRttB->isChecked());
+#ifdef VSYNC_SETTINGS
     sets().set("VSync", vsyncB->isChecked());
-#ifdef Q_OS_WIN
-    if (preventFullScreenB)
-        sets().set("PreventFullScreen", preventFullScreenB->isChecked());
 #endif
 }
diff --git a/src/modules/OpenGL2/OpenGL2.hpp b/src/modules/OpenGL2/OpenGL2.hpp
index 89f22d21..83aab459 100644
--- a/src/modules/OpenGL2/OpenGL2.hpp
+++ b/src/modules/OpenGL2/OpenGL2.hpp
@@ -20,15 +20,16 @@
 
 #include <Module.hpp>
 
-class OpenGL2 final : public Module
+class OpenGL2 : public Module
 {
 public:
     OpenGL2();
+
 private:
-    QList<Info> getModulesInfo(const bool) const override;
-    void *createInstance(const QString &) override;
+    QList<Info> getModulesInfo(const bool) const override final;
+    void *createInstance(const QString &) override final;
 
-    SettingsWidget *getSettingsWidget() override;
+    SettingsWidget *getSettingsWidget() override final;
 };
 
 /**/
@@ -37,18 +38,18 @@ private:
 
 class QCheckBox;
 
-class ModuleSettingsWidget final : public Module::SettingsWidget
+class ModuleSettingsWidget : public Module::SettingsWidget
 {
     Q_DECLARE_TR_FUNCTIONS(ModuleSettingsWidget)
+
 public:
     ModuleSettingsWidget(Module &);
+
 private:
-    void saveSettings() override;
+    void saveSettings() override final;
 
     QCheckBox *enabledB, *allowPboB, *hqScalingB;
-    QCheckBox *forceRttB;
+#ifdef VSYNC_SETTINGS
     QCheckBox *vsyncB;
-#ifdef Q_OS_WIN
-    QCheckBox *preventFullScreenB;
 #endif
 };
diff --git a/src/modules/OpenGL2/OpenGL2Common.cpp b/src/modules/OpenGL2/OpenGL2Common.cpp
index a5c451d9..4c518938 100644
--- a/src/modules/OpenGL2/OpenGL2Common.cpp
+++ b/src/modules/OpenGL2/OpenGL2Common.cpp
@@ -26,9 +26,8 @@
 #include <VideoFrame.hpp>
 #include <Functions.hpp>
 
-#include <QOffscreenSurface>
-#include <QOpenGLContext>
-#include <QOpenGLShader>
+#include <QGLContext>
+#include <QGLShader>
 #include <QResizeEvent>
 #include <QMatrix4x4>
 #include <QMatrix3x3>
@@ -38,6 +37,16 @@
 
 #include <cmath>
 
+#define QOpenGLContext QGLContext
+#define QOpenGLShader QGLShader
+
+#ifndef GL_MAJOR_VERSION
+    #define GL_MAJOR_VERSION 0x821B
+#endif
+#ifndef GL_MINOR_VERSION
+    #define GL_MINOR_VERSION 0x821C
+#endif
+
 /* OpenGL|ES 2.0 doesn't have those definitions */
 #ifndef GL_MAP_WRITE_BIT
     #define GL_MAP_WRITE_BIT 0x0002
@@ -88,7 +97,9 @@ OpenGL2Common::OpenGL2Common() :
     supportsShaders(false), canCreateNonPowerOfTwoTextures(false),
     glActiveTexture(nullptr),
 #endif
+#ifdef VSYNC_SETTINGS
     vSync(true),
+#endif
     hwAccellnterface(nullptr),
     shaderProgramVideo(nullptr), shaderProgramOSD(nullptr),
     texCoordYCbCrLoc(-1), positionYCbCrLoc(-1), texCoordOSDLoc(-1), positionOSDLoc(-1),
@@ -96,9 +107,6 @@ OpenGL2Common::OpenGL2Common() :
     target(0),
     Deinterlace(0),
     allowPBO(true), hasPbo(false),
-#ifdef Q_OS_WIN
-    preventFullScreen(false),
-#endif
     isPaused(false), isOK(false), hwAccelError(false), hasImage(false), doReset(true), setMatrix(true), correctLinesize(false), canUseHueSharpness(true),
     subsX(-1), subsY(-1), W(-1), H(-1), subsW(-1), subsH(-1), outW(-1), outH(-1), verticesIdx(0),
     glVer(0),
@@ -118,6 +126,7 @@ OpenGL2Common::OpenGL2Common() :
     rotAnimation.setEasingCurve(QEasingCurve::OutQuint);
     rotAnimation.setDuration(1000.0);
 }
+
 OpenGL2Common::~OpenGL2Common()
 {
     contextAboutToBeDestroyed();
@@ -130,24 +139,11 @@ void OpenGL2Common::deleteMe()
     delete this;
 }
 
-bool OpenGL2Common::testGL()
-{
-    QOpenGLContext glCtx;
-    if ((isOK = glCtx.create()))
-    {
-        QOffscreenSurface offscreenSurface;
-        offscreenSurface.create();
-        if ((isOK = glCtx.makeCurrent(&offscreenSurface)))
-            testGLInternal();
-    }
-    return isOK;
-}
-
 void OpenGL2Common::newSize(const QSize &size)
 {
     const bool canUpdate = !size.isValid();
     const QSize winSize = canUpdate ? widget()->size() : size;
-    const qreal dpr = widget()->devicePixelRatioF();
+    const qreal dpr = 1.0;
     if (!isRotate90())
     {
         Functions::getImageSize(aspectRatio, zoom, winSize.width(), winSize.height(), W, H, &subsX, &subsY);
@@ -167,6 +163,7 @@ void OpenGL2Common::newSize(const QSize &size)
             updateTimer.start(40);
     }
 }
+
 void OpenGL2Common::clearImg()
 {
     hasImage = false;
@@ -319,7 +316,9 @@ void OpenGL2Common::initializeGL()
         glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
     }
 
+#ifdef VSYNC_SETTINGS
     setVSync(vSync);
+#endif
 
     doReset = true;
     resetSphereVbo();
@@ -383,7 +382,7 @@ void OpenGL2Common::paintGL()
                 if (hqScaling)
                 {
                     // Must be set before "HWAccelInterface::init()" and must have "m_textureSize"
-                    maybeSetMipmaps(widget()->devicePixelRatioF());
+                    maybeSetMipmaps(1.0);
                 }
 
                 /* Prepare textures, register GL textures */
@@ -426,7 +425,7 @@ void OpenGL2Common::paintGL()
                 texCoordYCbCr[2] = texCoordYCbCr[6] = (videoFrame.linesize[0] == widths[0]) ? 1.0f : (widths[0] / (videoFrame.linesize[0] + 1.0f));
 
                 if (hqScaling)
-                    maybeSetMipmaps(widget()->devicePixelRatioF());
+                    maybeSetMipmaps(1.0);
             }
             resetDone = true;
             hasImage = false;
@@ -567,7 +566,7 @@ void OpenGL2Common::paintGL()
         }
         if (hqScaling)
         {
-            const qreal dpr = widget()->devicePixelRatioF();
+            const qreal dpr = 1.0;
             if (!resetDone)
                 maybeSetMipmaps(dpr);
             const bool useBicubic = (W * dpr > m_textureSize.width() || H * dpr > m_textureSize.height());
@@ -663,7 +662,7 @@ void OpenGL2Common::paintGL()
                 glBindBuffer(GL_PIXEL_UNPACK_BUFFER, 0);
         }
 
-        const QSizeF winSizeSubs = winSize * widget()->devicePixelRatioF();
+        const QSizeF winSizeSubs = winSize * 1.0;
         const float left   = (bounds.left() + subsX) * 2.0f / winSizeSubs.width() - osdOffset.x();
         const float right  = (bounds.right() + subsX + 1) * 2.0f / winSizeSubs.width() - osdOffset.x();
         const float top    = (bounds.top() + subsY) * 2.0f / winSizeSubs.height() - osdOffset.y();
@@ -817,36 +816,6 @@ void OpenGL2Common::testGLInternal()
     QWidget *w = widget();
     w->grabGesture(Qt::PinchGesture);
     w->setMouseTracking(true);
-#ifdef Q_OS_WIN
-    /*
-     * This property is read by QMPlay2 and it ensures that toolbar will be visible
-     * on fullscreen in Windows Vista and newer on nVidia and AMD drivers.
-    */
-    const bool canPreventFullScreen = (qstrcmp(w->metaObject()->className(), "QOpenGLWidget") != 0);
-    const QSysInfo::WinVersion winVer = QSysInfo::windowsVersion();
-    if (canPreventFullScreen && winVer >= QSysInfo::WV_6_0)
-    {
-        Qt::CheckState compositionEnabled;
-        if (!preventFullScreen)
-            compositionEnabled = Qt::PartiallyChecked;
-        else
-        {
-            compositionEnabled = Qt::Checked;
-            if (winVer <= QSysInfo::WV_6_1) //Windows 8 and 10 can't disable DWM composition
-            {
-                using DwmIsCompositionEnabledProc = HRESULT (WINAPI *)(BOOL *pfEnabled);
-                DwmIsCompositionEnabledProc DwmIsCompositionEnabled = (DwmIsCompositionEnabledProc)GetProcAddress(GetModuleHandleA("dwmapi.dll"), "DwmIsCompositionEnabled");
-                if (DwmIsCompositionEnabled)
-                {
-                    BOOL enabled = false;
-                    if (DwmIsCompositionEnabled(&enabled) == S_OK && !enabled)
-                        compositionEnabled = Qt::PartiallyChecked;
-                }
-            }
-        }
-        w->setProperty("preventFullScreen", (int)compositionEnabled);
-    }
-#endif
 }
 
 bool OpenGL2Common::initGLProc()
@@ -881,6 +850,7 @@ bool OpenGL2Common::initGLProc()
 
     return true;
 }
+
 #ifndef OPENGL_ES2
 void OpenGL2Common::showOpenGLMissingFeaturesMessage()
 {
@@ -1006,6 +976,7 @@ void OpenGL2Common::mousePress(QMouseEvent *e)
         }
     }
 }
+
 void OpenGL2Common::mouseMove(QMouseEvent *e)
 {
     if ((moveVideo || moveOSD) && (e->buttons() & Qt::LeftButton))
@@ -1027,6 +998,7 @@ void OpenGL2Common::mouseMove(QMouseEvent *e)
         updateGL(true);
     }
 }
+
 void OpenGL2Common::mouseRelease(QMouseEvent *e)
 {
     if ((moveVideo || moveOSD) && e->button() == Qt::LeftButton)
@@ -1051,6 +1023,7 @@ void OpenGL2Common::mousePress360(QMouseEvent *e)
         mousePos = e->pos();
     }
 }
+
 void OpenGL2Common::mouseMove360(QMouseEvent *e)
 {
     if (mouseWrapped)
@@ -1072,7 +1045,6 @@ void OpenGL2Common::mouseMove360(QMouseEvent *e)
         mouseTime = currTime;
 
         mousePos = newMousePos;
-        if (e->source() == Qt::MouseEventNotSynthesized)
         {
             if (canWrapMouse)
                 mouseWrapped = Functions::wrapMouse(widget(), mousePos, 1);
@@ -1084,6 +1056,7 @@ void OpenGL2Common::mouseMove360(QMouseEvent *e)
         updateGL(true);
     }
 }
+
 void OpenGL2Common::mouseRelease360(QMouseEvent *e)
 {
     if (buttonPressed && e->button() == Qt::LeftButton)
@@ -1099,11 +1072,13 @@ void OpenGL2Common::mouseRelease360(QMouseEvent *e)
         buttonPressed = false;
     }
 }
+
 inline void OpenGL2Common::resetSphereVbo()
 {
     memset(sphereVbo, 0, sizeof sphereVbo);
     nIndices = 0;
 }
+
 inline void OpenGL2Common::deleteSphereVbo()
 {
     if (nIndices > 0)
@@ -1112,6 +1087,7 @@ inline void OpenGL2Common::deleteSphereVbo()
         resetSphereVbo();
     }
 }
+
 void OpenGL2Common::loadSphere()
 {
     const quint32 slices = 50;
diff --git a/src/modules/OpenGL2/OpenGL2Common.hpp b/src/modules/OpenGL2/OpenGL2Common.hpp
index 60604799..c1b09d18 100644
--- a/src/modules/OpenGL2/OpenGL2Common.hpp
+++ b/src/modules/OpenGL2/OpenGL2Common.hpp
@@ -21,8 +21,7 @@
 #include <VideoFrame.hpp>
 #include <VideoAdjustment.hpp>
 
-#include <QOpenGLShaderProgram>
-
+#include <QGLShaderProgram>
 #include <QVariantAnimation>
 #include <QCoreApplication>
 #include <QImage>
@@ -33,7 +32,9 @@
     #include <GL/glext.h>
 #endif
 
-#if defined OPENGL_ES2 && !defined APIENTRY
+#define QOpenGLShaderProgram QGLShaderProgram
+
+#if !defined APIENTRY
     #define APIENTRY
 #endif
 
@@ -48,6 +49,7 @@ public:
     inline RotAnimation(OpenGL2Common &glCommon) :
         glCommon(glCommon)
     {}
+
 private:
     void updateCurrentValue(const QVariant &value) override;
 
@@ -70,6 +72,7 @@ class OpenGL2Common
     using GLMapBufferRange = void *(APIENTRY *)(GLenum, GLintptr, GLsizeiptr, GLbitfield);
     using GLMapBuffer      = void *(APIENTRY *)(GLenum, GLbitfield);
     using GLUnmapBuffer    = GLboolean(APIENTRY *)(GLenum);
+
 public:
     OpenGL2Common();
     virtual ~OpenGL2Common();
@@ -78,7 +81,7 @@ public:
 
     virtual QWidget *widget() = 0;
 
-    bool testGL();
+    virtual bool testGL() = 0;
     virtual bool setVSync(bool enable) = 0;
     virtual void updateGL(bool requestDelayed) = 0;
 
@@ -86,6 +89,7 @@ public:
     void clearImg();
 
     void setSpherical(bool spherical);
+
 protected:
     void initializeGL();
     void paintGL();
@@ -110,9 +114,12 @@ protected:
     GLMapBuffer glMapBuffer = nullptr;
     GLUnmapBuffer glUnmapBuffer = nullptr;
 
+#ifdef VSYNC_SETTINGS
     bool vSync;
+#endif
 
     void dispatchEvent(QEvent *e, QObject *p);
+
 private:
     void maybeSetMipmaps(qreal dpr);
 
@@ -133,6 +140,7 @@ private:
     inline void resetSphereVbo();
     inline void deleteSphereVbo();
     void loadSphere();
+
 public:
     HWAccelInterface *hwAccellnterface;
     QStringList videoAdjustmentKeys;
@@ -155,10 +163,6 @@ public:
     quint32 pbo[4];
     bool allowPBO, hasPbo, hqScaling = false;
 
-#ifdef Q_OS_WIN
-    bool preventFullScreen;
-#endif
-
     bool isPaused, isOK, hwAccelError, hasImage, doReset, setMatrix, correctLinesize, canUseHueSharpness, m_useMipmaps = false;
     int subsX, subsY, W, H, subsW, subsH, outW, outH, verticesIdx;
     int glVer;
diff --git a/src/modules/OpenGL2/OpenGL2Widget.cpp b/src/modules/OpenGL2/OpenGL2Widget.cpp
index 11b26fcf..2c1a8172 100644
--- a/src/modules/OpenGL2/OpenGL2Widget.cpp
+++ b/src/modules/OpenGL2/OpenGL2Widget.cpp
@@ -1,6 +1,6 @@
 /*
     QMPlay2 is a video and audio player.
-    Copyright (C) 2010-2019  Błażej Szczygieł
+    Copyright (C) 2010-2017  Błażej Szczygieł
 
     This program is free software: you can redistribute it and/or modify
     it under the terms of the GNU Lesser General Public License as published
@@ -18,12 +18,13 @@
 
 #include "OpenGL2Widget.hpp"
 
-#include <QOpenGLContext>
+#include <QMPlay2Core.hpp>
 
 OpenGL2Widget::OpenGL2Widget()
 {
-    connect(&updateTimer, SIGNAL(timeout()), this, SLOT(update()));
+    connect(&updateTimer, SIGNAL(timeout()), this, SLOT(updateGL())); // updateGL() from the base class
 }
+
 OpenGL2Widget::~OpenGL2Widget()
 {
     makeCurrent();
@@ -34,46 +35,66 @@ QWidget *OpenGL2Widget::widget()
     return this;
 }
 
+bool OpenGL2Widget::testGL()
+{
+    makeCurrent();
+    if ((isOK = isValid()))
+        testGLInternal();
+    doneCurrent();
+    return isOK;
+}
+
 bool OpenGL2Widget::setVSync(bool enable)
 {
-    QSurfaceFormat fmt = format();
-    vSync = enable;
-    if (!isValid())
+#ifdef VSYNC_SETTINGS
+    bool doDoneCurrent = false;
+    if (QGLContext::currentContext() != context())
     {
-        fmt.setSwapBehavior(QSurfaceFormat::DoubleBuffer); //Probably it doesn't work
-        fmt.setSwapInterval(enable); //Does it work on QOpenGLWidget?
-        setFormat(fmt);
-        return true;
+        makeCurrent();
+        doDoneCurrent = true;
     }
-    return (fmt.swapInterval() == enable);
+    using SwapInterval = int (APIENTRY *)(int); // BOOL is just normal int in Windows, APIENTRY declares nothing on non-Windows platforms
+    SwapInterval swapInterval = NULL;
+    swapInterval = (SwapInterval)context()->getProcAddress("glXSwapIntervalMESA");
+    if (!swapInterval)
+        swapInterval = (SwapInterval)context()->getProcAddress("glXSwapIntervalSGI");
+    if (swapInterval)
+        swapInterval(enable);
+    if (doDoneCurrent)
+        doneCurrent();
+    vSync = enable;
+#else
+    Q_UNUSED(enable)
+#endif
+    return true;
 }
+
 void OpenGL2Widget::updateGL(bool requestDelayed)
 {
     if (requestDelayed)
-        QMetaObject::invokeMethod(this, "update", Qt::QueuedConnection);
+        QCoreApplication::postEvent(this, new QEvent(QEvent::UpdateRequest), Qt::LowEventPriority);
     else
-        update();
+        QGLWidget::updateGL();
 }
 
 void OpenGL2Widget::initializeGL()
 {
-    connect(context(), SIGNAL(aboutToBeDestroyed()), this, SLOT(aboutToBeDestroyed()), Qt::DirectConnection);
     OpenGL2Common::initializeGL();
 }
+
 void OpenGL2Widget::paintGL()
 {
+    glClear(GL_COLOR_BUFFER_BIT);
     OpenGL2Common::paintGL();
 }
 
-void OpenGL2Widget::aboutToBeDestroyed()
+void OpenGL2Widget::resizeGL(int w, int h)
 {
-    makeCurrent();
-    contextAboutToBeDestroyed();
-    doneCurrent();
+    glViewport(0, 0, w, h);
 }
 
 bool OpenGL2Widget::event(QEvent *e)
 {
     dispatchEvent(e, parent());
-    return QOpenGLWidget::event(e);
+    return QGLWidget::event(e);
 }
diff --git a/src/modules/OpenGL2/OpenGL2Widget.hpp b/src/modules/OpenGL2/OpenGL2Widget.hpp
index 3e8bc14e..3a5c3729 100644
--- a/src/modules/OpenGL2/OpenGL2Widget.hpp
+++ b/src/modules/OpenGL2/OpenGL2Widget.hpp
@@ -1,6 +1,6 @@
 /*
     QMPlay2 is a video and audio player.
-    Copyright (C) 2010-2019  Błażej Szczygieł
+    Copyright (C) 2010-2017  Błażej Szczygieł
 
     This program is free software: you can redistribute it and/or modify
     it under the terms of the GNU Lesser General Public License as published
@@ -16,29 +16,34 @@
     along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
-#pragma once
+#ifndef OPENGL2WIDGET_HPP
+#define OPENGL2WIDGET_HPP
 
 #include <OpenGL2Common.hpp>
 
-#include <QSurfaceFormat>
-#include <QOpenGLWidget>
+#include <QGLWidget>
 
-class OpenGL2Widget final : public QOpenGLWidget, public OpenGL2Common
+class OpenGL2Widget : public QGLWidget, public OpenGL2Common
 {
     Q_OBJECT
+
 public:
     OpenGL2Widget();
-    ~OpenGL2Widget();
+        ~OpenGL2Widget() final;
+
+    QWidget *widget() override final;
 
-    QWidget *widget() override;
+    bool testGL() override final;
+    bool setVSync(bool enable) override final;
+    void updateGL(bool requestDelayed) override final;
 
-    bool setVSync(bool enable) override;
-    void updateGL(bool requestDelayed) override;
+    void initializeGL() override final;
+    void paintGL() override final;
 
-    void initializeGL() override;
-    void paintGL() override;
-private slots:
-    void aboutToBeDestroyed();
 private:
-    bool event(QEvent *e) override;
+    void resizeGL(int w, int h) override final;
+
+    bool event(QEvent *e) override final;
 };
+
+#endif // OPENGL2WIDGET_HPP
diff --git a/src/modules/OpenGL2/OpenGL2Writer.cpp b/src/modules/OpenGL2/OpenGL2Writer.cpp
index 72fe4f70..ebdeefa0 100644
--- a/src/modules/OpenGL2/OpenGL2Writer.cpp
+++ b/src/modules/OpenGL2/OpenGL2Writer.cpp
@@ -18,18 +18,14 @@
 
 #include <OpenGL2Writer.hpp>
 
-#include <OpenGL2Window.hpp>
 #include <OpenGL2Widget.hpp>
 
 #include <HWAccelInterface.hpp>
 #include <VideoFrame.hpp>
 
-#include <QGuiApplication>
-
 OpenGL2Writer::OpenGL2Writer(Module &module)
     : drawable(nullptr)
     , allowPBO(true)
-    , forceRtt(false)
 {
     addParam("W");
     addParam("H");
@@ -42,6 +38,7 @@ OpenGL2Writer::OpenGL2Writer(Module &module)
 
     SetModule(module);
 }
+
 OpenGL2Writer::~OpenGL2Writer()
 {
     if (drawable)
@@ -65,21 +62,10 @@ bool OpenGL2Writer::set()
         m_hqScaling = newHqScaling;
         doReset = true;
     }
-
+#ifdef VSYNC_SETTINGS
     vSync = sets().getBool("VSync");
     if (drawable && !drawable->setVSync(vSync))
         doReset = true;
-
-    const bool newForceRtt = sets().getBool("ForceRtt");
-    if (forceRtt != newForceRtt)
-        doReset = true;
-    forceRtt = newForceRtt;
-
-#ifdef Q_OS_WIN
-    bool newPreventFullScreen = sets().getBool("PreventFullScreen");
-    if (preventFullScreen != newPreventFullScreen)
-        doReset = true;
-    preventFullScreen = newPreventFullScreen;
 #endif
 
     return !doReset && sets().getBool("Enabled");
@@ -182,6 +168,7 @@ void OpenGL2Writer::writeVideo(const VideoFrame &videoFrame)
     }
     drawable->updateGL(drawable->sphericalView);
 }
+
 void OpenGL2Writer::writeOSD(const QList<const QMPlay2OSD *> &osds)
 {
     QMutexLocker mL(&drawable->osdMutex);
@@ -205,8 +192,6 @@ QString OpenGL2Writer::name() const
     QString glStr = drawable->glVer ? QString("%1.%2").arg(drawable->glVer / 10).arg(drawable->glVer % 10) : "2";
     if (drawable->hwAccellnterface)
         glStr += " " + drawable->hwAccellnterface->name();
-    if (useRtt)
-        glStr += " (render-to-texture)";
 #ifdef OPENGL_ES2
     return "OpenGL|ES " + glStr;
 #else
@@ -216,27 +201,15 @@ QString OpenGL2Writer::name() const
 
 bool OpenGL2Writer::open()
 {
-    static const QString platformName = QGuiApplication::platformName();
-    useRtt = platformName.startsWith("wayland") || platformName == "android" || forceRtt;
-    if (useRtt)
-    {
-        //Don't use rtt when videoDock has native window
-        const QWidget *videoDock = QMPlay2Core.getVideoDock();
-        useRtt = !videoDock->internalWinId() || (videoDock == videoDock->window());
-    }
-    if (useRtt)
-        drawable = new OpenGL2Widget;
-    else
-        drawable = new OpenGL2Window;
+    drawable = new OpenGL2Widget;
     drawable->hwAccellnterface = m_hwAccelInterface;
-#ifdef Q_OS_WIN
-    drawable->preventFullScreen = preventFullScreen;
-#endif
     drawable->allowPBO = allowPBO;
     drawable->hqScaling = m_hqScaling;
     if (drawable->testGL())
     {
+#ifdef VSYNC_SETTINGS
         drawable->setVSync(vSync);
+#endif
         bool hasBrightness = false, hasContrast = false, hasSharpness = false;
         if (!drawable->videoAdjustmentKeys.isEmpty())
         {
diff --git a/src/modules/OpenGL2/OpenGL2Writer.hpp b/src/modules/OpenGL2/OpenGL2Writer.hpp
index 7881da78..501ddcaa 100644
--- a/src/modules/OpenGL2/OpenGL2Writer.hpp
+++ b/src/modules/OpenGL2/OpenGL2Writer.hpp
@@ -27,8 +27,10 @@ class OpenGL2Common;
 class OpenGL2Writer final : public VideoWriter
 {
     Q_DECLARE_TR_FUNCTIONS(OpenGL2Writer)
+
 public:
     OpenGL2Writer(Module &);
+
 private:
     ~OpenGL2Writer();
 
@@ -58,10 +60,8 @@ private:
     OpenGL2Common *drawable;
     bool allowPBO;
     bool m_hqScaling = false;
-    bool forceRtt, useRtt;
+#ifdef VSYNC_SETTINGS
     bool vSync;
-#ifdef Q_OS_WIN
-    bool preventFullScreen;
 #endif
 };
 
diff --git a/src/modules/PortAudio/3rdparty/CoreAudio/AudioDevice.h b/src/modules/PortAudio/3rdparty/CoreAudio/AudioDevice.h
index 8ddf0b10..515006f0 100644
--- a/src/modules/PortAudio/3rdparty/CoreAudio/AudioDevice.h
+++ b/src/modules/PortAudio/3rdparty/CoreAudio/AudioDevice.h
@@ -51,17 +51,12 @@
 
 #include <CoreServices/CoreServices.h>
 #include <CoreAudio/CoreAudio.h>
+#include <AvailabilityMacros.h>
 
 #include <qglobal.h>
 
 #ifndef DEPRECATED_LISTENER_API
-#    if !defined(__MAC_10_11)
-#        define __MAC_10_11 101100
-#    endif
-#    ifndef QT_MACOS_PLATFORM_SDK_EQUAL_OR_ABOVE
-#        define QT_MACOS_PLATFORM_SDK_EQUAL_OR_ABOVE QT_OSX_PLATFORM_SDK_EQUAL_OR_ABOVE
-#    endif
-#    if !QT_MACOS_PLATFORM_SDK_EQUAL_OR_ABOVE(__MAC_10_11)
+#    if MAC_OS_X_VERSION_MIN_REQUIRED < 101100
 #        define DEPRECATED_LISTENER_API
 #        warning "Using the deprecated PropertyListener API; at least it works"
 #    endif
diff --git a/src/modules/PortAudio/PortAudioWriter.cpp b/src/modules/PortAudio/PortAudioWriter.cpp
index aead169e..736945e7 100644
--- a/src/modules/PortAudio/PortAudioWriter.cpp
+++ b/src/modules/PortAudio/PortAudioWriter.cpp
@@ -23,6 +23,10 @@
     #define MMSYSERR_NODRIVER 6
 #endif
 
+#if QT_VERSION < QT_VERSION_CHECK(5, 0, 0)
+    #define QStringLiteral QString::fromUtf8
+#endif
+
 #ifdef Q_OS_MACOS
     #include "3rdparty/CoreAudio/AudioDeviceList.h"
     #include "3rdparty/CoreAudio/AudioDevice.h"
@@ -47,6 +51,7 @@ PortAudioWriter::PortAudioWriter(Module &module) :
 
     SetModule(module);
 }
+
 PortAudioWriter::~PortAudioWriter()
 {
 #ifdef Q_OS_MACOS
@@ -130,6 +135,7 @@ bool PortAudioWriter::processParams(bool *paramsCorrected)
 
     return readyWrite();
 }
+
 qint64 PortAudioWriter::write(const QByteArray &arr)
 {
     if (!readyWrite())
@@ -192,6 +198,7 @@ qint64 PortAudioWriter::write(const QByteArray &arr)
 
     return arr.size();
 }
+
 void PortAudioWriter::pause()
 {
     if (readyWrite())
@@ -253,6 +260,7 @@ bool PortAudioWriter::openStream()
     }
     return false;
 }
+
 bool PortAudioWriter::startStream()
 {
     const PaError e = Pa_StartStream(stream);
@@ -266,6 +274,7 @@ bool PortAudioWriter::startStream()
     }
     return true;
 }
+
 inline bool PortAudioWriter::writeStream(const QByteArray &arr)
 {
     const PaError e = Pa_WriteStream(stream, arr.constData(), arr.size() / outputParameters.channelCount / sizeof(float));
@@ -288,6 +297,7 @@ inline bool PortAudioWriter::writeStream(const QByteArray &arr)
     }
     return (e != paUnanticipatedHostError);
 }
+
 qint64 PortAudioWriter::playbackError()
 {
     QMPlay2Core.logError("PortAudio :: " + tr("Playback error"));
@@ -302,6 +312,7 @@ bool PortAudioWriter::isNoDriverError() const
     return errorInfo && errorInfo->hostApiType == paMME && errorInfo->errorCode == MMSYSERR_NODRIVER;
 }
 #endif
+
 bool PortAudioWriter::reopenStream()
 {
     Pa_CloseStream(stream);
diff --git a/src/modules/PortAudio/PortAudioWriter.hpp b/src/modules/PortAudio/PortAudioWriter.hpp
index 20ff55d8..b458e9ca 100644
--- a/src/modules/PortAudio/PortAudioWriter.hpp
+++ b/src/modules/PortAudio/PortAudioWriter.hpp
@@ -29,25 +29,25 @@
 class AudioDevice;
 #endif
 
-class PortAudioWriter final : public Writer
+class PortAudioWriter : public Writer
 {
     Q_DECLARE_TR_FUNCTIONS(PortAudioWriter)
 public:
     PortAudioWriter(Module &);
 private:
-    ~PortAudioWriter();
+    ~PortAudioWriter() final;
 
-    bool set() override;
+    bool set() override final;
 
-    bool readyWrite() const override;
+    bool readyWrite() const override final;
 
-    bool processParams(bool *paramsCorrected) override;
-    qint64 write(const QByteArray &) override;
-    void pause() override;
+    bool processParams(bool *paramsCorrected) override final;
+    qint64 write(const QByteArray &) override final;
+    void pause() override final;
 
-    QString name() const override;
+    QString name() const override final;
 
-    bool open() override;
+    bool open() override final;
 
     /**/
 
diff --git a/src/modules/PulseAudio/PulseAudio.hpp b/src/modules/PulseAudio/PulseAudio.hpp
index 006f749d..e59f7046 100644
--- a/src/modules/PulseAudio/PulseAudio.hpp
+++ b/src/modules/PulseAudio/PulseAudio.hpp
@@ -20,15 +20,15 @@
 
 #include <Module.hpp>
 
-class PulseAudio final : public Module
+class PulseAudio : public Module
 {
 public:
     PulseAudio();
 private:
-    QList<Info> getModulesInfo(const bool) const override;
-    void *createInstance(const QString &) override;
+    QList<Info> getModulesInfo(const bool) const override final;
+    void *createInstance(const QString &) override final;
 
-    SettingsWidget *getSettingsWidget() override;
+    SettingsWidget *getSettingsWidget() override final;
 };
 
 /**/
@@ -38,13 +38,13 @@ private:
 class QDoubleSpinBox;
 class QCheckBox;
 
-class ModuleSettingsWidget final : public Module::SettingsWidget
+class ModuleSettingsWidget : public Module::SettingsWidget
 {
     Q_DECLARE_TR_FUNCTIONS(ModuleSettingsWidget)
 public:
     ModuleSettingsWidget(Module &);
 private:
-    void saveSettings() override;
+    void saveSettings() override final;
 
     QCheckBox *enabledB;
     QDoubleSpinBox *delayB;
diff --git a/src/modules/PulseAudio/PulseAudioWriter.hpp b/src/modules/PulseAudio/PulseAudioWriter.hpp
index 8ba6eb64..4d816b29 100644
--- a/src/modules/PulseAudio/PulseAudioWriter.hpp
+++ b/src/modules/PulseAudio/PulseAudioWriter.hpp
@@ -23,23 +23,23 @@
 
 #include <QCoreApplication>
 
-class PulseAudioWriter final : public Writer
+class PulseAudioWriter : public Writer
 {
     Q_DECLARE_TR_FUNCTIONS(PulseAudioWriter)
 public:
     PulseAudioWriter(Module &);
-    ~PulseAudioWriter();
+    ~PulseAudioWriter() final;
 private:
-    bool set() override;
+    bool set() override final;
 
-    bool readyWrite() const override;
+    bool readyWrite() const override final;
 
-    bool processParams(bool *paramsCorrected) override;
-    qint64 write(const QByteArray &) override;
+    bool processParams(bool *paramsCorrected) override final;
+    qint64 write(const QByteArray &) override final;
 
-    QString name() const override;
+    QString name() const override final;
 
-    bool open() override;
+    bool open() override final;
 
     /**/
 
diff --git a/src/modules/QPainter/QPainter.hpp b/src/modules/QPainter/QPainter.hpp
index 7257c675..b142be81 100644
--- a/src/modules/QPainter/QPainter.hpp
+++ b/src/modules/QPainter/QPainter.hpp
@@ -20,15 +20,15 @@
 
 #include <Module.hpp>
 
-class QPainterSW final : public Module
+class QPainterSW : public Module
 {
 public:
     QPainterSW();
 private:
-    QList<Info> getModulesInfo(const bool) const override;
-    void *createInstance(const QString &) override;
+    QList<Info> getModulesInfo(const bool) const override final;
+    void *createInstance(const QString &) override final;
 
-    SettingsWidget *getSettingsWidget() override;
+    SettingsWidget *getSettingsWidget() override final;
 };
 
 /**/
@@ -37,13 +37,13 @@ private:
 
 class QCheckBox;
 
-class ModuleSettingsWidget final : public Module::SettingsWidget
+class ModuleSettingsWidget : public Module::SettingsWidget
 {
     Q_DECLARE_TR_FUNCTIONS(ModuleSettingsWidget)
 public:
     ModuleSettingsWidget(Module &);
 private:
-    void saveSettings() override;
+    void saveSettings() override final;
 
     QCheckBox *enabledB;
 };
